<ui:composition xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalform" styleClass="form-horizontal">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

            <h1>#{messages['gazelle.dds.ListPatients']}</h1>
            <s:div id="allPatientsDiv">
                <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                               value="#{patientManager.filter.urlParameters}"/>

                <!--@formatter:off-->
                <script>
                    updateUrl("globalform:filterUrlParameters");
                    jq162("#globalform\\:filterUrlParameters").bind('change', function () {
                        updateUrl("globalform:filterUrlParameters");
                    });
                </script>
                <!--@formatter:on-->
                <ui:decorate id="decorationId" template="/layout/panels/_panel_filter_criteria.xhtml">
                    <div class="row">
                        <div class="col-lg-6">
                            <ui:include src="/filter/filterDate.xhtml">
                                <ui:param name="filter" value="#{patientManager.filter}"/>
                                <ui:param name="filterId" value="date"/>
                                <ui:param name="filterName" value="#{messages['gazelle.dds.CreationDAte']}"/>
                                <ui:param name="filterForm" value="allPatientsDiv"/>
                            </ui:include>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{patientManager.filter}"/>
                                <ui:param name="filterId" value="country"/>
                                <ui:param name="filterName" value="#{messages['gazelle.dds.CountryCode']}"/>
                                <ui:param name="filterForm" value="allPatientsDiv"/>
                            </ui:include>
                        </div>
                        <div class="col-lg-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{patientManager.filter}"/>
                                <ui:param name="filterId" value="gender"/>
                                <ui:param name="filterName" value="#{messages['gazelle.dds.Gender']}"/>
                                <ui:param name="filterForm" value="allPatientsDiv"/>
                            </ui:include>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{patientManager.filter}"/>
                                <ui:param name="filterId" value="religion"/>
                                <ui:param name="filterName" value="#{messages['gazelle.dds.Religion']}"/>
                                <ui:param name="filterForm" value="allPatientsDiv"/>
                            </ui:include>
                        </div>
                        <div class="col-lg-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{patientManager.filter}"/>
                                <ui:param name="filterId" value="race"/>
                                <ui:param name="filterName" value="#{messages['gazelle.dds.Race']}"/>
                                <ui:param name="filterForm" value="allPatientsDiv"/>
                            </ui:include>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-6">
                            <div class="form-group">
                                <label class="col-sm-4 control-label">
                                    <h:outputText value="#{messages['gazelle.dds.FirstName_2']}"/>
                                </label>
                                <div class="col-sm-5">
                                    <h:inputText value="#{patientManager.firstname}" styleClass=" form-control">
                                        <a4j:ajax event="keyup" render="allPatientsDiv"/>
                                    </h:inputText>
                                </div>
                                <div class="col-sm-1">
                                    <a4j:commandLink event="click"
                                                     actionListener="#{patientManager.setFirstname(null)}"
                                                     render="allPatientsDiv">
                                        <span class="gzl-icon-times"/>
                                    </a4j:commandLink>
                                </div>
                            </div>

                        </div>
                        <div class="col-lg-6">
                            <div class="form-group">
                                <label class="col-sm-4 control-label">
                                    <h:outputText
                                            value="#{messages['gazelle.dds.FirstName_2']} (#{messages['net.ihe.gazelle.maven.Alternative']})"/>
                                </label>
                                <div class="col-sm-5">
                                    <h:inputText value="#{patientManager.firstnameAlter}" styleClass=" form-control">
                                        <a4j:ajax event="keyup" render="allPatientsDiv"/>
                                    </h:inputText>
                                </div>
                                <div class="col-sm-1">
                                    <a4j:commandLink event="click"
                                                     actionListener="#{patientManager.setFirstnameAlter(null)}"
                                                     render="allPatientsDiv">
                                        <span class="gzl-icon-times"/>
                                    </a4j:commandLink>
                                </div>
                            </div>

                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-6">
                            <div class="form-group">
                                <label class="col-sm-4 control-label">
                                    <h:outputText value="#{messages['gazelle.dds.LastName_2']}"/>
                                </label>
                                <div class="col-sm-5">
                                    <h:inputText value="#{patientManager.lastname}" styleClass=" form-control">
                                        <a4j:ajax event="keyup" render="allPatientsDiv"/>
                                    </h:inputText>
                                </div>
                                <div class="col-sm-1">
                                    <a4j:commandLink event="click"
                                                     actionListener="#{patientManager.setLastname(null)}"
                                                     render="allPatientsDiv">
                                        <span class="gzl-icon-times"/>
                                    </a4j:commandLink>
                                </div>
                            </div>
                        </div>
                        <div class="col-lg-6">
                            <div class="form-group">
                                <label class="col-sm-4 control-label">
                                    <h:outputText
                                            value="#{messages['gazelle.dds.LastName_2']} (#{messages['net.ihe.gazelle.maven.Alternative']})"/>
                                </label>
                                <div class="col-sm-5">
                                    <h:inputText value="#{patientManager.lastnameAlter}" styleClass=" form-control">
                                        <a4j:ajax event="keyup" render="allPatientsDiv"/>
                                    </h:inputText>
                                </div>
                                <div class="col-sm-1">
                                    <a4j:commandLink event="click"
                                                     actionListener="#{patientManager.setLastnameAlter(null)}"
                                                     render="allPatientsDiv">
                                        <span class="gzl-icon-times"/>
                                    </a4j:commandLink>
                                </div>
                            </div>
                        </div>
                    </div>
                    <ui:define name="filter_buttons">
                        <a4j:commandLink actionListener="#{patientManager.resetFilter()}"
                                         title="#{messages['gazelle.dds.ResetCriteria']}"
                                         render="globalform">
                            <span class="fa fa-times-circle"/>
                        </a4j:commandLink>
                    </ui:define>
                </ui:decorate>

                <rich:dataTable id="listPatientTable" var="patient" value="#{patientManager.patientDataModel}"
                                rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="ds">
                    <g:column sortBy="#{'person.firstNameSex.firstName'}" filterBy="#{'person.firstNameSex.firstName'}">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.dds.FirstName']}"/>
                        </ui:define>
                        <h:outputText value="#{patient.person.firstNameSex.firstName}"/>
                    </g:column>
                    <g:column sortBy="#{'person.firstAlternativeName'}" filterBy="#{'person.firstAlternativeName'}">
                        <ui:define name="header">
                            <h:outputText
                                    value="#{messages['gazelle.dds.FirstName']} (#{messages['net.ihe.gazelle.maven.Alternative']})"/>
                        </ui:define>
                        <h:outputText value="#{patient.person.firstAlternativeName}"/>
                    </g:column>
                    <g:column sortBy="#{'person.lastName.value'}" filterBy="#{'person.lastName.value'}">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.dds.LastName']}"/>
                        </ui:define>
                        <h:outputText value="#{patient.person.lastName.value}"/>
                    </g:column>
                    <g:column sortBy="#{'person.lastAlternativeName'}" filterBy="#{'person.lastAlternativeName'}">
                        <ui:define name="header">
                            <h:outputText
                                    value="#{messages['gazelle.dds.LastName']} (#{messages['net.ihe.gazelle.maven.Alternative']})"/>
                        </ui:define>
                        <h:outputText value="#{patient.person.lastAlternativeName}"/>
                    </g:column>
                    <g:column sortBy="#{'person.sex.description'}" filterBy="#{'person.sex.description'}">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.dds.Gender']}"/>
                        </ui:define>
                        <h:outputText value="#{patient.person.sex.description}"/>
                    </g:column>
                    <g:column sortBy="#{'person.race.description'}" filterBy="#{'person.race.description'}">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.dds.Race']}"/>
                        </ui:define>
                        <h:outputText value="#{patient.person.race.description}"/>
                    </g:column>
                    <g:column sortBy="#{'person.religion.description'}" filterBy="#{'person.religion.description'}">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.dds.Religion']}"/>
                        </ui:define>
                        <h:outputText value="#{patient.person.religion.description}"/>
                    </g:column>
                    <g:column id="PatientCounColumn" sortBy="#{'country.printableName'}"
                              filterBy="#{'country.printableName'}">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.dds.CountryCode']}"/>
                        </ui:define>
                        <h:outputText value="#{patient.country.printableName}"/>
                    </g:column>
                    <g:column sortBy="#{'creationDate'}" sortOrder="descending">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.dds.CreationDAte']}"/>
                        </ui:define>
                        <div class="gzl-never-wrap">
                            <g:date value="#{patient.creationDate}"/>
                        </div>
                    </g:column>
                    <g:column id="PatientActionColumn">
                        <ui:define name="header">
                            <h:outputText value="#{messages['gazelle.common.Action']}"/>
                        </ui:define>
                        <div class="gzl-never-wrap">
                            <a4j:commandLink action="#{patientManager.getPermanentLink(patient)}"
                                             title="#{messages['gazelle.dds.ViewPatient']}">
                                <span class="gzl-icon-search"/>
                            </a4j:commandLink>

                            <a4j:commandLink event="click" execute="@this"
                                             title="#{messages['gazelle.dds.AddPatientToSharePatientList']}"
                                             action="#{patientManager.addPatientToSharePatientList(patient)}"
                                             render="patientListToSend"
                                             oncomplete="window.location.href='#anchorToTheSelectedPatientDiv'">
                                         <span class="gzl-icon-stack">
                                          <span class="gzl-icon-user gzl-icon-stack-1x"/>
                                          <span class="gzl-icon-share-alt gzl-icon-stack-1x gzl-icon-stack-bottom-right  gzl-color-light-orange"/>
                                          <span class="gzl-icon-plus gzl-icon-stack-1x gzl-icon-stack-top-left"/>
                                        </span>
                            </a4j:commandLink>

                        </div>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="listPatientTable"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
            </s:div>
            <s:div id="patientListToSend">
                <h:panelGroup rendered="#{patientManager.selectedPatientList.size() &gt; 0}">
                    <ui:decorate template="/layout/panels/_panel_title.xhtml">
                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['gazelle.dds.ViewSelectedPatients']}"/>
                            <a4j:commandLink event="click" execute="@this"
                                             title="#{messages['gazelle.dds.SharePatient']}"
                                             action="#{patientManager.shareSelectedPatientList()}">
                                <span class="gzl-icon-stack">
                                    <span class="gzl-icon-user gzl-icon-stack-1x"/>
                                    <span class="gzl-icon-share-alt gzl-icon-stack-1x gzl-icon-stack-bottom-right  gzl-color-light-orange"/>
                                </span>
                            </a4j:commandLink>
                            <a name="anchorToTheSelectedPatientDiv"/>
                            <a4j:commandLink event="click"
                                             render="patientListToSend" execute="@this"
                                             title="#{messages['gazelle.dds.ResetSelectedPatientList']}"
                                             actionListener="#{patientManager.resetSelectedPatientList()}">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>
                        </ui:define>


                        <rich:list var="pat" value="#{patientManager.selectedPatientList}" type="unordered"
                                   title="Patient List">
                            <h:outputText>(#{pat.id})</h:outputText>
                            <gdk:spacer width="4"/>
                            <h:outputText value="#{pat.person.lastAlternativeName}"
                                          rendered="#{pat.person.lastName == null}"/>
                            <h:outputText value="#{pat.person.lastName.value}"
                                          rendered="#{pat.person.lastName != null}"/>
                            <gdk:spacer width="4"/>
                            <h:outputText value="#{pat.person.firstAlternativeName}"
                                          rendered="#{pat.person.firstNameSex == null}"/>
                            <h:outputText value="#{pat.person.firstNameSex.firstName}"
                                          rendered="#{pat.person.firstNameSex != null}"/>
                        </rich:list>
                    </ui:decorate>
                </h:panelGroup>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
